#include <stdio.h>	
#include <windows.h>
#include "Serial.h"

float Yaw,Roll,Pitch;

void SERIAL (int serial_port, int baud_rate, int samples, int sampling_interval, int bytes_perFrame) {
 char Data[]= {"@"}, receive_buf[4096], X_ayis[10];
 int Data_length=sizeof(Data)/sizeof(char), loop, rxBytes, txBytes, gnuplotWindow=50;
 char strEuler[8]; //### Yaw: 0,360 ### Roll: -90,90 ### Pitch:-180,180
 int i,j,k;
 fclose(stderr);
 FILE *fp, *pipe, *fpGP_Yaw, *fpGP_Roll, *fpGP_Pitch;
 fp = fopen("measurements.txt","a"); 
 fclose(fp);
 fp = fopen("measurements.txt","r+"); 
 fseek (fp, 0, SEEK_END); 					 			    
 pipe = popen("gnuplot -persist","w"); 
 fpGP_Yaw = fopen("Yaw.dat","w"); 	   
 fpGP_Roll = fopen("Roll.dat","w"); 	
 fpGP_Pitch = fopen("Pitch.dat","w");  
 fclose(fpGP_Yaw);
 fclose(fpGP_Roll);
 fclose(fpGP_Pitch);
 
  if (SERIAL_Open(serial_port, baud_rate)) exit(0);

  for (loop=0; loop<samples; loop++) {  
   txBytes = SERIAL_Write(Data, Data_length-1);  
   Sleep(sampling_interval);
   rxBytes = SERIAL_Read(receive_buf, bytes_perFrame);
   receive_buf[rxBytes]='\0'; 
   i=j=k=0; //### Yaw: 0,360 ### Roll: -90,90 ### Pitch:-180,180 ###//
   while( receive_buf[j] != ('\n') ) {  
    do{
	   strEuler[i++] = receive_buf[j++];
    } while ( (receive_buf[j] != ',') & (receive_buf[j] != '\r') );
    strEuler[i]=0;
	if(k==0) Yaw = atof(strEuler);
    if(k==1) Roll = atof(strEuler);
	if(k==2) Pitch = atof(strEuler);
    i=0;
    j++;
	k++;
   } 
   printf ("%.0f, %.0f, %.0f          \r",Yaw, Roll, Pitch);
   fprintf(fp,"%.0f\t %.0f\t %.0f\n",Yaw, Roll, Pitch); 
   // Print to GNUPLOT
   sprintf(X_ayis, "%d", loop);
   fpGP_Yaw = fopen("Yaw.dat","a");
   fpGP_Roll = fopen("Roll.dat","a");
   fpGP_Pitch = fopen("Pitch.dat","a");
   if(loop>gnuplotWindow)	fprintf(pipe, "set xrange [%d:%d]\n",loop-(gnuplotWindow-1), loop);
   fprintf(fpGP_Yaw,"%s %.0f\n",X_ayis,Yaw);
   fprintf(fpGP_Roll,"%s %.0f\n",X_ayis,Roll);
   fprintf(fpGP_Pitch,"%s %.0f\n",X_ayis,Pitch);
   fprintf(pipe, "plot  'Yaw.dat' with lines linecolor 'blue' lw 2, \
						'Roll.dat' with lines linecolor 'red' lw 2, \
						'Pitch.dat' with lines linecolor 'green' lw 2; unset key\n");
   fclose(fpGP_Yaw);  
   fclose(fpGP_Roll); 
   fclose(fpGP_Pitch); 
   fflush(pipe);
  }
  
  SERIAL_Close();
 fclose(fp);
 fclose(pipe);

}

int main()
{
	int P_samples = 10000, ODR=10 , frame_bytes=32; /*frame_bytes max is 14*/
	SERIAL (55, 9600/*gnuplot@9600*/, P_samples, ODR, frame_bytes);
return(0);
}