// 8N1 serial port settings; used by SetCommState() 
#define stopBIT ONESTOPBIT
#define parityBIT NOPARITY
#define dataBITS 8
HANDLE hComm;

int SERIAL_Open(int No, int Baud) 
{
 char SerialPort[100][12] = { /* "\\\\.\\COMxx" reserves 12 characters */
	"\\\\.\\COM0",  "\\\\.\\COM1",  "\\\\.\\COM2",  "\\\\.\\COM3",  
	"\\\\.\\COM4",  "\\\\.\\COM5",  "\\\\.\\COM6",  "\\\\.\\COM7",  
	"\\\\.\\COM8",  "\\\\.\\COM9",  "\\\\.\\COM10", "\\\\.\\COM11", 
	"\\\\.\\COM12", "\\\\.\\COM13", "\\\\.\\COM14", "\\\\.\\COM15", 
	"\\\\.\\COM16", "\\\\.\\COM17",	"\\\\.\\COM18", "\\\\.\\COM19", 
	"\\\\.\\COM20", "\\\\.\\COM21", "\\\\.\\COM22", "\\\\.\\COM23", 
	"\\\\.\\COM24", "\\\\.\\COM25", "\\\\.\\COM26", "\\\\.\\COM27", 
	"\\\\.\\COM28", "\\\\.\\COM29", "\\\\.\\COM30", "\\\\.\\COM31",
	"\\\\.\\COM32", "\\\\.\\COM33", "\\\\.\\COM34", "\\\\.\\COM35",
	"\\\\.\\COM36", "\\\\.\\COM37", "\\\\.\\COM38", "\\\\.\\COM39",
	"\\\\.\\COM40", "\\\\.\\COM41", "\\\\.\\COM42", "\\\\.\\COM43",
	"\\\\.\\COM44", "\\\\.\\COM45", "\\\\.\\COM46", "\\\\.\\COM47",
	"\\\\.\\COM48", "\\\\.\\COM49", "\\\\.\\COM50", "\\\\.\\COM51",
	"\\\\.\\COM52", "\\\\.\\COM53", "\\\\.\\COM54", "\\\\.\\COM55",
	"\\\\.\\COM56", "\\\\.\\COM57", "\\\\.\\COM58", "\\\\.\\COM59",
	"\\\\.\\COM60", "\\\\.\\COM61", "\\\\.\\COM62", "\\\\.\\COM63",
	"\\\\.\\COM64", "\\\\.\\COM65", "\\\\.\\COM66", "\\\\.\\COM67",
	"\\\\.\\COM68", "\\\\.\\COM69", "\\\\.\\COM70", "\\\\.\\COM71",
	"\\\\.\\COM72", "\\\\.\\COM73", "\\\\.\\COM74", "\\\\.\\COM75",
	"\\\\.\\COM76", "\\\\.\\COM77", "\\\\.\\COM78", "\\\\.\\COM79",
	"\\\\.\\COM80", "\\\\.\\COM81", "\\\\.\\COM82", "\\\\.\\COM83",
	"\\\\.\\COM84", "\\\\.\\COM85", "\\\\.\\COM86", "\\\\.\\COM87",
	"\\\\.\\COM88", "\\\\.\\COM89", "\\\\.\\COM90", "\\\\.\\COM91",
	"\\\\.\\COM92", "\\\\.\\COM93", "\\\\.\\COM94", "\\\\.\\COM95",
	"\\\\.\\COM96", "\\\\.\\COM97", "\\\\.\\COM98", "\\\\.\\COM99" };	
  hComm = CreateFile (SerialPort[No], GENERIC_READ|GENERIC_WRITE, 
					  0, NULL, OPEN_EXISTING, 0, NULL); 	                      
  if(hComm==INVALID_HANDLE_VALUE) {
    printf("\nUnable to open the selected Serial Port\n");
	return(1);
  }
  // WINDOWS DCB structure: Declare and initialize a new structure 
  // and obtain current settings via GetCommState() 
  DCB COM_settings = {0}; 						 
  COM_settings.DCBlength = sizeof(COM_settings);  
  GetCommState(hComm, &COM_settings);			 
  // Set Baud Rate, Data Bits, Stop/Parity Bit; configure via SetCommState() 
  COM_settings.BaudRate = Baud;
  COM_settings.ByteSize = dataBITS;
  COM_settings.StopBits = stopBIT;
  COM_settings.Parity 	= parityBIT;
  SetCommState(hComm, &COM_settings);
  // Create the event mask EV_RXCHAR via function SetCommMask()
  SetCommMask(hComm, EV_RXCHAR);
 return(0);
}

int SERIAL_Write(char *txBuffer, int bytesToTransmit)
{
  DWORD bytesTransmitted;
	WriteFile(hComm, txBuffer, bytesToTransmit, &bytesTransmitted, NULL);
 return((int)bytesTransmitted);
}

void SERIAL_WaitToReceive()
{
  DWORD dwCommEvent;
	while (!WaitCommEvent(hComm, &dwCommEvent, NULL));
}

DWORD SERIAL_Read(char *rxBuffer, int bytesToReceive)
{
  DWORD bytesReceived;
	ReadFile(hComm, rxBuffer, bytesToReceive, &bytesReceived, NULL);
 return((int)bytesReceived);
}

void SERIAL_Close(void)
{
	CloseHandle(hComm);
}
